# ГруппаПакетовРесурсовЛокализации

## Синтаксис:

```bsl
Новый ГруппаПакетовРесурсовЛокализации()
```

## Методы

[ДобавитьПакет](#добавитьпакет) </br>
[Пакеты](#пакеты) </br>
[СодержитКлюч](#содержитключ) </br>
[ПолучитьРесурс](#получитьресурс) </br>
[ПолучитьСтроку](#получитьстроку) </br>
[ЗаполнитьШаблон](#заполнитьшаблон) </br>
[ИспользоватьПоУмолчанию](#использоватьпоумолчанию)


## ДобавитьПакет

**Синтаксис:**

```bsl
ДобавитьПакет(<Пакет>)
```

**Параметры:**

| Имя | Тип | Описание |
| -- | -- | -- |
| **Пакет** | [ПакетРесурсовЛокализации](ПакетРесурсовЛокализации.md) | Пакет ресурсов |

**Описание:**

Добавляет пакет в группу.


## Пакеты

**Синтаксис:**

```bsl
Пакеты()
```

**Возвращаемое значение:**

Тип: Массив из [ПакетРесурсовЛокализации](ПакетРесурсовЛокализации.md).

**Описание:**

Получает список пакетов группы.


## СодержитКлюч

**Синтаксис:**

```bsl
СодержитКлюч(<Ключ>)
```

**Параметры:**

| Имя | Тип | Описание |
| -- | -- | -- |
| **Ключ** | Строка | Имя ресурса |

**Возвращаемое значение:**

Тип: Булево.

**Описание:**

Проверяет наличие ресурса по ключу.


## ПолучитьРесурс

**Синтаксис:**

```bsl
ПолучитьРесурс(<Ключ>)
```

**Параметры:**

| Имя | Тип | Описание |
| -- | -- | -- |
| **Ключ** | Строка | Имя ресурса |

**Возвращаемое значение:**

Тип: Проивзольный.

**Описание:**

Получает значение ресурса по ключу. Возвращает `Неопределено` в случае, если ресурс не найден.


## ПолучитьСтроку

**Синтаксис:**

```bsl
ПолучитьСтроку(<ИмяРесурса>), <ЗначениеПараметра1-ЗначениеПараметра9>)
```

**Параметры:**

| Имя | Тип |  Значение по умолчанию | Описание |
| -- | -- | -- | -- |
| **ИмяРесурса** | Строка | | Имя ресурса |
| ЗначениеПараметра1-ЗначениеПараметра9 | Строка | `Неопределено` | Параметры, содержащие произвольные значения, строковые представления которых должны быть подставлены в шаблон |

**Возвращаемое значение:**

Тип: Строка, Неопределено.

**Описание:**

Получает строковое значение ресурса с подставлением параметров по принципу функции `СтрШаблон`. Возвращает `Неопределено` в случае, если ресурс не найден.


## ЗаполнитьШаблон

**Синтаксис:**

```bsl
ЗаполнитьШаблон(<Шаблон>)
```

**Параметры:**

| Имя | Тип | Описание |
| -- | -- | -- |
| **Шаблон** | Строка | Текст шаблона |

**Описание:**

Заполняет шаблон ресурсами из пакета заменяя конструкцию `{t(ИмяРесурса)}` на значение ресурса.


## ИспользоватьПоУмолчанию

**Синтаксис:**

```bsl
ИспользоватьПоУмолчанию()
```

**Описание:**

Устанавливает группу пакетов ресурсов по умолчанию.
