
# МенеджерРесурсовЛокализации

## Методы

[ПолучитьПакет](#получитьпакет) </br>
[ПолучитьПакеты](#получитьпакеты) </br>
[ДобавитьКаталог](#получитьпакеты) </br>
[ОчиститьКэш](#очиститькэш) </br>
[ОчиститьВсе](#очиститьвсе) </br>


## ПолучитьПакет

**Синтаксис:**

```bsl
ПолучитьПакет(<БазовоеИмя>, <КодЛокализации>)
```

**Параметры:**

| Имя | Тип | Значение по умолчанию | Описание |
| -- | -- | -- | -- |
| **БазовоеИмя** | Строка | | Базовое имя пакета |
| КодЛокализации | Строка | `Неопределено` | Код локализации (ru_RU, en_US, de, nl). Если значение не указано, то используется [текущая локаль](Мультиязычность.md#текущаялокаль). |

**Возвращаемое значение:**

Тип: [ПакетРесурсовЛокализации](ПакетРесурсовЛокализации.md).

**Описание:**

Получает пакет. В случае отсутствия пакета выбрасывается исключение.


## ПолучитьПакеты

**Синтаксис:**

```bsl
ПолучитьПакеты(<БазовыеИмена>, <КодЛокализации>)
```

**Параметры:**

| Имя | Тип | Значение по умолчанию | Описание |
| -- | -- | -- | -- |
| **БазовыеИмена** | Строка | | Перечень имен пакетов через запятую |
| КодЛокализации | Строка | `Неопределено` | Код локализации (ru_RU, en_US, de, nl). Если значение не указано, то используется [текущая локаль](Мультиязычность.md#текущаялокаль). |

**Возвращаемое значение:**

Тип: [ГруппаПакетовРесурсовЛокализации](ГруппаПакетовРесурсовЛокализации.md).

**Описание:**

Получает пакеты. В случае отсутствия одного из пакетов выбрасывается исключение.


## ДобавитьКаталог

**Синтаксис:**

```bsl
ДобавитьКаталог(<ПутьККаталогу>, <РасширениеРесурсов>, <ИскатьВПодкаталогах>)
```

**Параметры:**

| Имя | Тип | Значение по умолчанию | Описание |
| -- | -- | -- | -- |
| **ПутьККаталогу** | Строка | | Путь к каталогу относительно текущего каталога, либо абсольтный путь |
| РасширениеРесурсов | Строка | "properties" | Расширение файлов ресурсов без точки |
| ИскатьВПодкаталогах | Булево | `Истина` | Искать файлы в подкаталогах |

**Описание:**

Добавляет каталог файлов ресурсов.


## ОчиститьКэш

**Синтаксис:**

```bsl
ОчиститьКэш()
```

**Описание:**

Очищает кэш.


## ОчиститьВсе

**Синтаксис:**

```bsl
ОчиститьВсе()
```

**Описание:**

Очищает все данные.
