# Мультиязычность

## Методы

[ТекущаяЛокаль](#текущаялокаль) </br>
[УстановитьЛокаль](#установитьлокаль) </br>
[ЛокальПоУмолчанию](#локальпоумолчанию) </br>
[УстановитьЛокальПоУмолчанию](#установитьлокальпоумолчанию) </br>
[ТекущийЯзык](#текущийязык) </br>
[ТекущаяСтрана](#текущаястрана) </br>
[ПакетРесурсовПоУмолчанию](#пакетресурсовпоумолчанию) </br>
[УстановитьПакетРесурсовПоУмолчанию](#установитьпакетресурсовпоумолчанию) </br>
[ПолучитьРесурс](#получитьресурс) </br>
[ПолучитьСтроку](#получитьстроку) </br>
[ЗаполнитьШаблон](#заполнитьшаблон)


## ТекущаяЛокаль

**Синтаксис:**

```bsl
ТекущаяЛокаль()
```

**Возвращаемое значение:**

Тип: Строка.

**Описание:**

Получает текущую локаль.


## УстановитьЛокаль

**Синтаксис:**

```bsl
УстановитьЛокаль(<КодЛокализации>)
```

**Параметры:**

| Имя | Тип | Описание |
| -- | -- | -- |
| **КодЛокализации** | Строка | Код локализации (ru_RU, en_US, de, nl) |

**Описание:**

Устанавливает текущую локаль.


## ЛокальПоУмолчанию

**Синтаксис:**

```bsl
ЛокальПоУмолчанию()
```

**Возвращаемое значение:**

Тип: Строка.

**Описание:**

Получает локаль по умолчанию.


## УстановитьЛокальПоУмолчанию

**Синтаксис:**

```bsl
УстановитьЛокальПоУмолчанию(<КодЛокализации>)
```

**Параметры:**

| Имя | Тип | Описание |
| -- | -- | -- |
| **КодЛокализации** | Строка | Код локализации (ru_RU, en_US, de, nl) |

**Описание:**

Устанавливает локаль по умолчанию.


## ТекущийЯзык

**Синтаксис:**

```bsl
ТекущийЯзык()
```

**Возвращаемое значение:**

Тип: Строка.

**Описание:**

Получает код языка текущей локали.


## ТекущаяСтрана

**Синтаксис:**

```bsl
ТекущаяСтрана()
```

**Возвращаемое значение:**

Тип: Строка.

**Описание:**

Получает код страны текущей локали.


## ПакетРесурсовПоУмолчанию

**Синтаксис:**

```bsl
ПакетРесурсовПоУмолчанию()
```

**Возвращаемое значение:**

Тип: [ПакетРесурсовЛокализации](ПакетРесурсовЛокализации.md), [ГруппаПакетовРесурсовЛокализации](ГруппаПакетовРесурсовЛокализации.md).

**Описание:**

Получает пакет ресурсов по умолчанию.


## УстановитьПакетРесурсовПоУмолчанию

**Синтаксис:**

```bsl
УстановитьПакетРесурсовПоУмолчанию(<Пакет>)
```

**Параметры:**

| Имя | Тип | Описание |
| -- | -- | -- |
| **Пакет** | [ПакетРесурсовЛокализации](ПакетРесурсовЛокализации.md)</br> [ГруппаПакетовРесурсовЛокализации](ГруппаПакетовРесурсовЛокализации.md) | Пакет или группа пакетов ресурсов |

**Описание:**

Устанавливает пакет ресурсов по умолчанию.


## ПолучитьРесурс

**Синтаксис:**

```bsl
ПолучитьРесурс(<ИмяРесурса>)
```

**Параметры:**

| Имя | Тип | Описание |
| -- | -- | -- |
| **ИмяРесурса** | Строка | Имя ресурса |

**Возвращаемое значение:**

Тип: Проивзольный.

**Описание:**

Получает ресурс по имени из пакета ресурсов по умолчанию. Возвращает `Неопределено` в случае, если ресурс не найден.


## ПолучитьСтроку

**Синтаксис:**

```bsl
ПолучитьСтроку(<ИмяРесурса>), <ЗначениеПараметра1-ЗначениеПараметра9>)
```

**Параметры:**

| Имя | Тип |  Значение по умолчанию | Описание |
| -- | -- | -- | -- |
| **ИмяРесурса** | Строка | | Имя ресурса |
| ЗначениеПараметра1-ЗначениеПараметра9 | Строка | `Неопределено` | Параметры, содержащие произвольные значения, строковые представления которых должны быть подставлены в шаблон |

**Возвращаемое значение:**

Тип: Строка, Неопределено.

**Описание:**

Получает строковое значение ресурса из пакета ресурсов по умолчанию с подставлением параметров по принципу функции `СтрШаблон`. Возвращает `Неопределено` в случае, если ресурс не найден.


## ЗаполнитьШаблон

**Синтаксис:**

```bsl
ЗаполнитьШаблон(<Шаблон>, <Пакет>)
```

**Параметры:**

| Имя | Тип | Значение по умолчанию | Описание |
| -- | -- | -- | -- |
| **Шаблон** | Строка | | Текст шаблона |
| Пакет | Строка | `Неопределено` | [ПакетРесурсовЛокализации](ПакетРесурсовЛокализации.md)</br> [ГруппаПакетовРесурсовЛокализации](ГруппаПакетовРесурсовЛокализации.md) | Пакет или группа пакетов ресурсов. Если пакет не указан, то используется пакет по умолчанию. |

**Описание:**

Заполняет шаблон ресурсами из пакета заменяя конструкцию `{t(ИмяРесурса)}` на значение ресурса.