# ПакетРесурсовЛокализации

## Синтаксис:

```bsl
Новый ПакетРесурсовЛокализации(<БазовоеИмя>, <КодЛокализации>)
```

**Параметры:**

| Имя | Тип | Описание |
| -- | -- | -- |
| **БазовоеИмя** | Строка | Базовое имя пакета |
| **КодЛокализации** | Строка |  Код локализации (ru_RU, en_US, de, nl) |


## Методы

[БазовоеИмя](#базовоеимя) </br>
[Локаль](#локаль) </br>
[СодержитКлюч](#содержитключ) </br>
[ПолучитьРесурс](#получитьресурс) </br>
[ПолучитьСтроку](#получитьстроку) </br>
[ЗаполнитьШаблон](#заполнитьшаблон) </br>
[УстановитьРесурсы](#установитьресурсы) </br>
[УстановитьРодителя](#установитьродителя) </br>
[ИспользоватьПоУмолчанию](#использоватьпоумолчанию)


## БазовоеИмя

**Синтаксис:**

```bsl
БазовоеИмя()
```

**Возвращаемое значение:**

Тип: Строка.

**Описание:**

Получает базовое имя.


## Локаль

**Синтаксис:**

```bsl
Локаль()
```

**Возвращаемое значение:**

Тип: Строка.

**Описание:**

Получает код локализации.


## СодержитКлюч

**Синтаксис:**

```bsl
СодержитКлюч(<Ключ>)
```

**Параметры:**

| Имя | Тип | Описание |
| -- | -- | -- |
| **Ключ** | Строка | Имя ресурса |

**Возвращаемое значение:**

Тип: Булево.

**Описание:**

Проверяет наличие ресурса по ключу.


## ПолучитьРесурс

**Синтаксис:**

```bsl
ПолучитьРесурс(<Ключ>)
```

**Параметры:**

| Имя | Тип | Описание |
| -- | -- | -- |
| **Ключ** | Строка | Имя ресурса |

**Возвращаемое значение:**

Тип: Проивзольный.

**Описание:**

Получает значение ресурса по ключу. Возвращает `Неопределено` в случае, если ресурс не найден.


## ПолучитьСтроку

**Синтаксис:**

```bsl
ПолучитьСтроку(<ИмяРесурса>), <ЗначениеПараметра1-ЗначениеПараметра9>)
```

**Параметры:**

| Имя | Тип |  Значение по умолчанию | Описание |
| -- | -- | -- | -- |
| **ИмяРесурса** | Строка | | Имя ресурса |
| ЗначениеПараметра1-ЗначениеПараметра9 | Строка | `Неопределено` | Параметры, содержащие произвольные значения, строковые представления которых должны быть подставлены в шаблон |

**Возвращаемое значение:**

Тип: Строка, Неопределено.

**Описание:**

Получает строковое значение ресурса с подставлением параметров по принципу функции `СтрШаблон`. Возвращает `Неопределено` в случае, если ресурс не найден.


## ЗаполнитьШаблон

**Синтаксис:**

```bsl
ЗаполнитьШаблон(<Шаблон>)
```

**Параметры:**

| Имя | Тип | Описание |
| -- | -- | -- |
| **Шаблон** | Строка | Текст шаблона |

**Описание:**

Заполняет шаблон ресурсами из пакета заменяя конструкцию `{t(ИмяРесурса)}` на значение ресурса.


## УстановитьРесурсы

**Синтаксис:**

```bsl
УстановитьРесурсы(<Ресурсы>)
```

**Параметры:**

| Имя | Тип | Описание |
| -- | -- | -- |
| **Ресурсы** | Соответствие | Ресурсы |

**Описание:**

Устанавливает ресурсы пакета.


## УстановитьРодителя

**Синтаксис:**

```bsl
УстановитьРодителя(<Родитель>)
```

**Параметры:**

| Имя | Тип | Описание |
| -- | -- | -- |
| **Родитель** | [ПакетРесурсовЛокализации](ПакетРесурсовЛокализации.md) | Пакет ресурсов |

**Описание:**

Устанавливает родителя пакета.


## ИспользоватьПоУмолчанию

**Синтаксис:**

```bsl
ИспользоватьПоУмолчанию()
```

**Описание:**

Устанавливает пакетов ресурсов по умолчанию.